Last Comment Bug 752986 - [AccessFu] Use left right D-Pad keys for content navigation
: [AccessFu] Use left right D-Pad keys for content navigation
Status: VERIFIED FIXED
:
Product: Core
Classification: Components
Component: Disability Access APIs (show other bugs)
: Trunk
: ARM Android
: -- normal (vote)
: mozilla15
Assigned To: Eitan Isaacson [:eeejay]
:
: alexander :surkov
Mentors:
Depends on:
Blocks:
  Show dependency treegraph
 
Reported: 2012-05-08 10:48 PDT by Eitan Isaacson [:eeejay]
Modified: 2012-05-22 02:03 PDT (History)
2 users (show)
See Also:
Crash Signature:
(edit)
QA Whiteboard:
Iteration: ---
Points: ---
Has Regression Range: ---
Has STR: ---


Attachments
Bug 752986 - Change VC nav to left/right instead of up/down. Correct home/end constant names. (1.78 KB, patch)
2012-05-08 11:00 PDT, Eitan Isaacson [:eeejay]
no flags Details | Diff | Splinter Review
Bug 752986 - Change VC nav to left/right instead of up/down. Correct home/end constant names. (3.20 KB, patch)
2012-05-08 11:20 PDT, Eitan Isaacson [:eeejay]
dbolter: review+
Details | Diff | Splinter Review

Description Eitan Isaacson [:eeejay] 2012-05-08 10:48:26 PDT
Right now it is up/down. Pros/cons for changing this.
pro: getting back to the awesome bar is just one button press away.
pro: the virtual cursor position would be retained when navigating in
and out of the awesome bar.
con: feels to me counter intuitive.
con: don't know what to do about rtl setups.

After dicussing this with Marco, it makes sense to go ahead with it. VoiceOver uses left/right for content nav too. rtl should not be a real issue.
Comment 1 Eitan Isaacson [:eeejay] 2012-05-08 11:00:46 PDT
Created attachment 622046 [details] [diff] [review]
Bug 752986 - Change VC nav to left/right instead of up/down. Correct home/end constant names.

Retouched the comment there too, for some style consistency.
Comment 2 Eitan Isaacson [:eeejay] 2012-05-08 11:20:06 PDT
Created attachment 622054 [details] [diff] [review]
Bug 752986 - Change VC nav to left/right instead of up/down. Correct home/end constant names.

OK, I tested it this time :)
Comment 3 David Bolter [:davidb] 2012-05-08 12:44:11 PDT
Comment on attachment 622054 [details] [diff] [review]
Bug 752986 - Change VC nav to left/right instead of up/down. Correct home/end constant names.

Review of attachment 622054 [details] [diff] [review]:
-----------------------------------------------------------------

::: accessible/src/jsat/VirtualCursorController.jsm
@@ +59,5 @@
> +        if (Services.appinfo.OS == 'Android')
> +          // Return focus to browser chrome, which in Android is a native widget.
> +          Cc['@mozilla.org/android/bridge;1'].
> +            getService(Ci.nsIAndroidBridge).handleGeckoMessage(
> +              JSON.stringify({ gecko: { type: 'ToggleChrome:Focus' } }));

Do you need to set the virtual cursor position to null here?

@@ +65,3 @@
>        case aEvent.DOM_VK_RETURN:
> +        // XXX: It is true that desktop does not map the kp enter key to ENTER.
> +        // So for desktop we require a ctrl+return instead.

BTW what is "kp" enter key?
Comment 4 Eitan Isaacson [:eeejay] 2012-05-08 12:51:22 PDT
(In reply to David Bolter [:davidb] from comment #3)
> Comment on attachment 622054 [details] [diff] [review]
> Bug 752986 - Change VC nav to left/right instead of up/down. Correct
> home/end constant names.
> 
> Review of attachment 622054 [details] [diff] [review]:
> -----------------------------------------------------------------
> 
> ::: accessible/src/jsat/VirtualCursorController.jsm
> @@ +59,5 @@
> > +        if (Services.appinfo.OS == 'Android')
> > +          // Return focus to browser chrome, which in Android is a native widget.
> > +          Cc['@mozilla.org/android/bridge;1'].
> > +            getService(Ci.nsIAndroidBridge).handleGeckoMessage(
> > +              JSON.stringify({ gecko: { type: 'ToggleChrome:Focus' } }));
> 
> Do you need to set the virtual cursor position to null here?
> 

No. The added benefit of this change is you get to keep your place in the doc even if you navigate up to the awesomebar and back. So setting it to null wouldn't be good here.

> @@ +65,3 @@
> >        case aEvent.DOM_VK_RETURN:
> > +        // XXX: It is true that desktop does not map the kp enter key to ENTER.
> > +        // So for desktop we require a ctrl+return instead.
> 
> BTW what is "kp" enter key?

the d-pad center button is mapped to the keypad enter (kp), instead of the regular return. I could expand the acronym..
Comment 5 David Bolter [:davidb] 2012-05-08 12:57:49 PDT
Comment on attachment 622054 [details] [diff] [review]
Bug 752986 - Change VC nav to left/right instead of up/down. Correct home/end constant names.

Great. r=me

(In reply to Eitan Isaacson [:eeejay] from comment #4)
> (In reply to David Bolter [:davidb] from comment #3)
> > Comment on attachment 622054 [details] [diff] [review]

> > > +          Cc['@mozilla.org/android/bridge;1'].
> > > +            getService(Ci.nsIAndroidBridge).handleGeckoMessage(
> > > +              JSON.stringify({ gecko: { type: 'ToggleChrome:Focus' } }));
> > 
> > Do you need to set the virtual cursor position to null here?
> > 
> 
> No. The added benefit of this change is you get to keep your place in the
> doc even if you navigate up to the awesomebar and back. So setting it to
> null wouldn't be good here.

OK good that was my hunch, thanks.

> > BTW what is "kp" enter key?
> 
> the d-pad center button is mapped to the keypad enter (kp), instead of the
> regular return. I could expand the acronym..

Sure :)
Comment 6 Eitan Isaacson [:eeejay] 2012-05-08 17:28:06 PDT
http://hg.mozilla.org/integration/mozilla-inbound/rev/075804813c58
Comment 7 Ed Morley [:emorley] 2012-05-09 03:46:39 PDT
https://hg.mozilla.org/mozilla-central/rev/075804813c58
Comment 8 Marco Zehe (:MarcoZ) 2012-05-22 02:03:47 PDT
Verified in Fennec/15.0a1 2012-05-21

Note You need to log in before you can comment on or make changes to this bug.